KEEP32 ;
 ; --------------------------------------------------
 ;    * * * * *   K E E P I T   3 . 2   * * * * *
 ; --------------------------------------------------
 ;    >>>>      SYSTEM /12345 TO ENTER       <<<<
 ; --------------------------------------------------
 ;    >>>>      USE   *READ   FOR MENU       <<<<
 ; --------------------------------------------------
 ;
 ; COPYRIGHT (C) 1980, 1981 BY DENNIS BATHORY KITSZ
 ; ALL RIGHTS RESERVED.  NO PART OF THIS PROGRAM MAY
 ; BE REPRODUCED BY ANY MEANS, ELECTRONIC, ELECTRO-
 ; MECHANICAL, OR IN PRINT, WHETHER BY METHODS IN
 ; USE OR CONCEIVED IN THE FUTURE, WITHOUT SPECIFIC
 ; WRITTEN PERMISSION OF THE AUTHOR.
 ;
 INKEYS	EQU	4099H	;INKEY$ BYTE STORAGE AREA
 KYSCAN	EQU	03FBH	;KEYBOARD SCAN ROUTINE
 PORTFF	EQU	403DH	;CASSETTE OUTPUT PORT
 KPLACE	EQU	401AH	;1-BYTE KEYSTROKE STORE
 SHIFTR	EQU	4019H	;STORAGE FOR LC DRIVER
 RESTRT	EQU	4004H	;BASIC INTERP PATCH POINT
 STGEND	EQU	40A0H	;END OF STRINGS POINTER
 STACKR	EQU	40E8H	;BASIC STACK POINTER
 VAREND	EQU	40FDH	;END OF VARIABLE POINTER
 READY	EQU	06CCH	;RETURN TO READY INTACT
 MEMTOP	EQU	40B1H	;TOP OF BASIC MEMORY
 SETPTS	EQU	4000H	;SETPOINT RESTART ADDRESS
 WRTBYT	EQU	0264H	;ROM BYTE WRITE ROUTINE
 BYTE	EQU	1D78H	;ROM READ KEYS & TOKENIZE
 VIDEO	EQU	3C00H	;FIRST SCREEN LOCATION
 ;
 	ORG	3039H
 ; PREPARE RAM AREAS FOR USE
 START	LD	HL,(40B1H)
 	LD	DE,(40A0H)
 	LD	B,7
 	DEC	HL
 	DEC	DE
 	DJNZ	$-2
 	LD	(40B1H),HL
 	LD	(40A0H),DE
 	INC	HL
 	PUSH	HL
 	POP	IY
 ; READY INTERPRETER VECTOR PATCH
 ; GET CURRENT CONTENTS OF 4004H
 	LD	A,0C3H
 	LD	(IY+0),A
 	LD	DE,(RESTRT)
 	LD	(IY+1),E
 	LD	(IY+2),D
 	LD	(IY+3),A
 	LD	DE,SKPSTP
 	LD	(IY+4),E
 	LD	(IY+5),D
 GRINS	INC	HL
 	INC	HL
 	INC	HL
 	LD	(RESTRT),HL
 	XOR	A
 	LD	(SHIFTR),A
 ; CALL CLEAR AND RETURN TO BASIC
 RSLVII	CALL	01C9H
 	CALL	1B61H
 	LD	HL,0111H
 	CALL	28A7H
 	JP	READY
 ; START KEYBOARD SCAN
 KBPFIX	LD	HL,4036H
 	LD	BC,3801H
 	LD	D,0
 ; CHECK EACH ROW OF KEYS
 KEYPRS	LD	A,(BC)
 	LD	E,A
 	AND	E
 	JR	NZ,STROKE
 	LD	(HL),A
 ; INC AND ROTATE TO CHECK NEXT ROW
 RECHEK	INC	D
 	INC	L
 	RLC	C
 	LD	A,C
 ; CHECK IF LAST ROW (NOT INCL. SHIFT)
 	SUB	80H
 	JR	NZ,KEYPRS
 ; CHECK IF KEYBOARD CLEAR
 	LD	B,7
 CLRMEM	DEC	L
 	ADD	A,(HL)
 	DJNZ	CLRMEM
 	AND	A
 	LD	A,0
 	RET	NZ
 ; RESET AUTOREPEAT DELAY TO 0
 	LD	(KPLACE),A
 	RET
 ; IF KEYSTROKE FOUND CHECK AUTOREPEAT LOOP
 STROKE	AND	(HL)
 	JR	Z,FOUND
 	LD	A,(INKEYS)
 	AND	A
 	JR	NZ,RECHEK
 	LD	A,(KPLACE)
 	INC	A
 	LD	(KPLACE),A
 	CP	0FFH
 	JR	Z,DECA
 	PUSH	BC
 	LD	B,0FFH
 TMWSTE	DJNZ	TMWSTE
 	POP	BC
 	JR	RECHEK
 DECA	DEC	A
 	LD	(KPLACE),A
 ; GET AND SAVE FOUND KEYBOARD BYTE
 	LD	A,E
 FOUND	LD	(HL),E
 	LD	A,D
 	RLCA
 	RLCA
 	RLCA
 	LD	D,A
 	LD	C,1
 BACKUP	LD	A,C
 	AND	E
 	JR	NZ,AROUND
 	INC	D
 	RLC	C
 	JR	BACKUP
 AROUND	LD	A,(3880H)
 	LD	B,A
 	LD	A,D
 	ADD	A,40H
 	CP	60H
 	JR	NC,Z0429H
 	LD	D,A
 	LD	A,(3840H)
 	AND	10H
 	JR	NZ,CNTROL
 	LD	A,D
 	RRC	B
 	JR	C,GOAWAY
 	ADD	A,20H
 	JR	GOAWAY
 CNTROL	LD	A,D
 	SUB	40H
 	JR	GOAWAY
 Z0429H	SUB	70H
 	JR	NC,Z043DH
 	ADD	A,40H
 	CP	3CH
 	JR	C,Z0435H
 	XOR	10H
 Z0435H	RRC	B
 	JR	NC,GOAWAY
 	XOR	10H
 	JR	GOAWAY
 Z043DH	RLCA
 	RRC	B
 	JR	NC,Z0443H
 	INC	A
 Z0443H	LD	HL,TABLET
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	A,(HL)
 	JR	GOAWAY
 TABLET	DEFW	0D0DH
 	DEFW	1F1FH
 	DEFW	0101H
 	DEFW	1B5BH
 	DEFW	000AH
 	DEFW	1808H
 	DEFW	1909H
 	DEFW	2020H
 GOAWAY	LD	D,A
 BEEEEP	LD	A,(3810H)
 	CP	1
 	JR	NZ,BLEEEP
 	LD	A,(3880H)
 	CP	1
 	JR	NZ,BLEEEP
 	LD	A,(SHIFTR)
 	XOR	1
 	LD	(SHIFTR),A
 	LD	BC,500H
 	CALL	0060H
 	RET
 ; DEBOUNCE
 BLEEEP	LD	BC,180H
 	CALL	0060H
 	LD	A,D
 ; BEEP ROUTINE ON FOUND KEYSTROKE
 	PUSH	BC
 	PUSH	AF
 	LD	B,40H
 	LD	A,(PORTFF)
 	AND	0FDH
 	LD	H,A
 	OR	2
 	LD	L,A
 BEEPER	LD	A,L
 	OUT	(0FFH),A
 	LD	A,H
 	OUT	(0FFH),A
 	PUSH	BC
 	LD	B,40H
 FREQCY	DJNZ	FREQCY
 	POP	BC
 	DJNZ	BEEPER
 	POP	AF
 	POP	BC
 	JP	0452H
 ; CHECK FOR STATUS OF BASIC STACK
 SKPSTP	EQU	$
 BEGIN	EX	(SP),HL
 	LD	A,L
 	CP	5BH
 	JR	NZ,NOTRDY
 	LD	A,H
 	CP	1DH
 NOTRDY	EX	(SP),HL
 	JP	NZ,BYTE
 ; CHECK TO SEE IF SPECIAL STAR (*) COMMAND
 	CALL	BYTE
 	CP	0CFH
 	JR	Z,OKSTAR
 	DEC	HL
 	JP	(IY)
 OKSTAR	CALL	BYTE
 	JP	Z,SYNERR
 ; CHECK STATUS OF SAVE COMMAND
 SAVE	CP	0ADH
 	JR	Z,SAVER
 	CP	0BBH
 	JR	Z,RENEW
 	CP	0A2H
 	JP	Z,OPENER
 	CP	0CCH
 	JP	Z,STPSET
 	CP	0C8H
 	JP	Z,MEMSET
 	CP	0F2H
 	JR	Z,INBEEP
 	CP	0B2H
 	JR	Z,LOWCAS
 	CP	0A0H
 	JR	Z,BIPOFF
 	CP	0AAH
 	JR	Z,UPPPER
 	CP	08BH
 	JR	Z,MENU
 SYNERR	JP	1997H
 ; THIS IS THE MENU
 MENU	LD	HL,INTRO1
 	CALL	28A7H
 	LD	HL,INTRO2
 	CALL	28A7H
 	LD	HL,INTRO3
 	CALL	28A7H
 	LD	HL,INTRO4
 	CALL	28A7H
 	JR	READYX
 ; THIS PUTS LOWER CASE IN PLACE
 LOWCAS	LD	A,1
 	LD	(SHIFTR),A
 	LD	HL,LOWER
 	LD	(401EH),HL
 	JR	READYX
 ; THIS REMOVES LOWER CASE DISPLAY
 UPPPER	LD	HL,0458H
 	LD	(401EH),HL
 	JR	READYX
 ; THIS REMOVES KBPFIX ROUTINE
 BIPOFF	LD	HL,03E3H
 	LD	(4016H),HL
 	JR	READYX
 ; THIS PUTS KBPFIX IN PLACE
 INBEEP	LD	HL,KBPFIX
 	LD	(4016H),HL
 READYX	JP	READY
 ; THIS IS BEGINNING OF RENEW SEQUENCE
 RENEW	LD	DE,(40A4H)
 	LD	A,0FFH
 	LD	(DE),A
 	CALL	1AFCH
 	INC	HL
 	LD	(40F9H),HL
 	LD	SP,(40E8H)
 FGHIJ	JP	RSLVII
 ; THIS CHECKS NEXT BYTE FOR RUN COMMAND
 SAVER	CALL	BYTE
 	CP	0D0H
 	JR	NZ,SYNERR
 	CALL	BYTE
 	CP	8EH
 	JP	NZ,MACH
 ; CHECK FOR QUOTATION MARK DELIMITER
 	CALL	BYTE
 	CP	022H
 	JR	NZ,SYNERR
 ; CHECK TO SEE THAT NAME IS IN PLACE
 	CALL	BYTE
 	JP	Z,24A0H
 ; SAVE BASIC POINTERS IN STACK
 	PUSH	HL
 	PUSH	AF
 	PUSH	DE
 	PUSH	BC
 ; DEFINE TAPE DRIVE 0, TURN ON RECORDER
 ; THEN WRITE LEADER AND SYNC BYTE
 ; AND WRITE MACHINE PROGRAM CODE 55H
 	XOR	A
 	CALL	0212H
 	CALL	0287H
 	LD	A,55H
 	CALL	WRTBYT
 ; WRITE PROGRAM NAME TO TAPE
 	LD	B,06
 	DEC	HL
 NAMES	CALL	BYTE
 	CP	22H
 	JR	Z,NEXTBT
 	CALL	WRTBYT
 	DJNZ	NAMES
 	JR	DUMP
 ; FILL OUT WITH 20H (ASCII BLANKS) IF NECESSARY
 NEXTBT	LD	A,20H
 	CALL	WRTBYT
 	DJNZ	NEXTBT
 ; DUMP FIRST TWO PAGES (4000 TO 41FF) TO TAPE
 DUMP	LD	HL,SETPTS
 	CALL	OUTSEQ
 	CALL	OUTSEQ
 ; DUMP REST OF POINTERS (4200 TO 42E9) TO TAPE
 	LD	B,0E9H
 	CALL	OUTSEQ
 ; FIND END OF PROGRAM VARIABLES AND ARRAYS
 	LD	DE,(VAREND)
 ; DUMP FIRST SEGMENT OF PROGRAM TO TAPE
 	LD	A,E
 	SUB	L
 	LD	B,A
 	CALL	OUTSEQ
 ; DUMP PROGRAM TO TAPE PAGE BY PAGE
 NXTPGE	LD	A,H
 	DEC	A
 	CP	D
 	JR	Z,FINSH1
 	CALL	OUTSEQ
 	JR	NXTPGE
 ; FIND BEGINNING OF STRING STORAGE AREA
 FINSH1	LD	HL,(STACKR)
 ; FIND TOP OF AVAILABLE MEMORY
 	LD	DE,(MEMTOP)
 ; DUMP FIRST SEGMENT OF STRING-TO-MEMORY END
 	INC	DE
 	LD	A,E
 	SUB	L
 	LD	B,A
 	CALL	OUTSEQ
 ; DUMP REMAINDER OF MEMORY PAGE BY PAGE
 NXTBCH	LD	A,H
 	DEC	A
 	CP	D
 	JR	Z,KEEPIT
 	CALL	OUTSEQ
 	JR	NXTBCH
 ; DUMP KEEPIT CONTROL BYTES
 KEEPIT	LD	HL,(40B1H)
 	LD	B,10H
 	CALL	OUTSEQ
 ; DUMP COMPLETE VIDEO MEMORY
 	LD	HL,VIDEO
 	LD	B,4
 CDEF	PUSH	BC
 	CALL	PREOUT
 	POP	BC
 	DJNZ	CDEF
 ; WRITE END OF PROGRAM CODE (78)
 	LD	A,78H
 	CALL	WRTBYT
 ; WRITE START ADDRESS AFTER LOAD (06CCH)
 	LD	A,0CCH
 	CALL	WRTBYT
 	LD	A,06
 	CALL	WRTBYT
 ; RESTORE BASIC INFORMATION TO REGISTERS
 	POP	BC
 	POP	DE
 	POP	AF
 	POP	HL
 ; RETURN TO BASIC PROGRAM IN PROGRESS
 	JP	READY
 ; OUTPUT SEQUENCE SUBROUTINE
 ; WRITE BLOCK HEADER CODE (3C)
 PREOUT	LD	B,0
 OUTSEQ	LD	A,3CH
 	CALL	WRTBYT
 ; GET NUMBER OF BYTES TO WRITE
 	LD	A,B
 	CALL	WRTBYT
 ; GET START ADDRESS LSB, SAVE IN C (CHECKSUM)
 	LD	A,L
 	LD	C,A
 	CALL	WRTBYT
 ; GET START ADDRESS MSB, SAVE IN C (CHECKSUM)
 	LD	A,C
 	ADD	A,H
 	LD	C,A
 	LD	A,H
 	CALL	WRTBYT
 ; GET BLOCK OF DATA, WRITE, AND SAVE IN C
 WRTPGE	LD	A,C
 	ADD	A,(HL)
 	LD	C,A
 	LD	A,(HL)
 	CALL	WRTBYT
 	INC	HL
 	DJNZ	WRTPGE
 ; GET CHECKSUM FROM C AND WRITE TO TAPE
 	LD	A,C
 	CALL	WRTBYT
 	RET
 ; GET REST OF DATA AND CONVERT
 OPENER	CALL	BYTE
 	CP	22H
 	JP	NZ,SYNERR
 	PUSH	HL
 	CALL	XX99
 	CALL	01C9H
 	JR	NEXT99
 ; GET 16 SCREEN POSITIONS READY (10H)
 CONTNT	LD	A,D
 	LD	HL,3C40H
 	AND	0F0H
 	CALL	RRRRS
 	LD	A,D
 	AND	0FH
 	CALL	HEXASC
 	LD	(HL),A
 	INC	HL
 	LD	A,E
 	AND	0F0H
 	CALL	RRRRS
 	LD	A,E
 	AND	0FH
 	CALL	HEXASC
 	LD	(HL),A
 	LD	HL,3C80H
 	LD	B,10H
 ; DISPLAY CONTENTS OF ADDRESS CHOSEN
 CONT02	LD	A,(DE)
 	AND	0F0H
 	CALL	RRRRS
 	LD	A,(DE)
 	AND	0FH
 	CALL	HEXASC
 	LD	(HL),A
 	INC	HL
 	INC	HL
 	INC	DE
 ; REDO IT 16 TIMES FOR FULL LINE
 	DJNZ	CONT02
 ; DISPLAY ASCII VALUES TOO
 	LD	B,10H
 	PUSH	BC
 	DEC	DE
 	DJNZ	$-1
 	POP	BC
 	PUSH	BC
 	LD	HL,3CC0H
 BBBA	LD	A,(DE)
 	LD	(HL),A
 	INC	HL
 	INC	HL
 	INC	HL
 	INC	DE
 	DJNZ	BBBA
 	POP	BC
 	DEC	DE
 	DJNZ	$-1
 	RET
 ; SCAN FOR EDIT / GET THIRD SCREEN LINE
 NEXT99	CALL	CONTNT
 ; SCAN KEYBOARD FOR BREAK, ARROWS
 EDITOR	LD	A,(3840H)
 	RLA
 	RLA
 	JR	NC,AAAA
 	INC	DE
 	JR	STNDRD
 AAAA	RLA
 	JR	NC,AAAB
 	DEC	DE
 	JR	STNDRD
 AAAB	LD	B,10H
 	RLA
 	JR	NC,AAAC
 	DEC	DE
 	DJNZ	$-1
 	JR	STNDRD
 AAAC	RLA
 	JR	NC,BREEK
 	INC	DE
 	DJNZ	$-1
 	JR	STNDRD
 BREEK	RLA
 	JR	NC,AAAD
 	POP	HL
 	JP	READY
 ; DISPLAY EDITING / GET FIFTH SCREEN LINE
 AAAD	LD	HL,3D01H
 	LD	(HL),5FH
 	DEC	HL
 	LD	(HL),5FH
 	LD	B,2
 AAAE	PUSH	DE
 	PUSH	HL
 	CALL	0049H
 	POP	HL
 	POP	DE
 	CP	47H
 	JR	NC,EDITOR
 	CP	30H
 	JR	C,EDITOR
 	CP	3AH
 	JR	C,AAAF
 	CP	40H
 	JR	C,EDITOR
 AAAF	LD	(HL),A
 	INC	HL
 	DJNZ	AAAE
 ; CONVERT CHOSEN DATA TO HEX
 	DEC	HL
 	CALL	ASCHEX
 	LD	C,A
 	DEC	HL
 	CALL	LLLLS
 	ADD	A,C
 ; PUT NEW BYTE IN PLACE
 	LD	(DE),A
 	INC	DE
 ; DISPLAY REVISED LINE OF DATA
 STNDRD	CALL	CONTNT
 	CALL	DELAY
 	JR	EDITOR
 ; ASCII TO HEXADECIMAL CONVERSION
 ASCHEX	LD	A,(HL)
 	SUB	30H
 	CP	0AH
 	RET	C
 	SUB	7
 	RET
 ; HEXADECIMAL TO ASCII CONVERSION
 HEXASC	ADD	A,30H
 	CP	3AH
 	RET	C
 	ADD	A,7
 	RET
 ; RIGHT ROTATES FOR CONVERSIONS
 RRRRS	RRCA
 	RRCA
 	RRCA
 	RRCA
 	CALL	HEXASC
 	LD	(HL),A
 	INC	HL
 	RET
 ; LEFT ROTATES FOR CONVERSION
 LLLLS	CALL	ASCHEX
 	RLCA
 	RLCA
 	RLCA
 	RLCA
 	RET
 ; DELAY FOR SCREEN DISPLAYS
 DELAY	LD	BC,2000H
 	CALL	0060H
 	RET
 ; GET/CONVERT ASCII FROM BUFFER
 ; TO HEXADECIMAL ADDRESS
 XX99	LD	B,4
 SSSS	CALL	BYTE
 	PUSH	AF
 	DJNZ	SSSS
 	POP	AF
 	LD	(HL),A
 	CALL	ASCHEX
 	LD	E,A
 	POP	AF
 	LD	(HL),A
 	CALL	LLLLS
 	ADD	A,E
 	LD	E,A
 	POP	AF
 	LD	(HL),A
 	CALL	ASCHEX
 	LD	D,A
 	POP	AF
 	LD	(HL),A
 	CALL	LLLLS
 	ADD	A,D
 	LD	D,A
 	RET
 ; RESULT OF ABOVE IN DE REGISTER
 ; CHECK FOR "OPEN" COMMAND
 MACH	CP	0A2H
 	JR	NZ,SYN2
 ; CHECK FOR QUOTATION MARK DELIMITER
 	CALL	BYTE
 	SUB	22H
 SYN2	JP	NZ,SYNERR
 ; TURN ON TAPE DRIVE, WRITE LEADER
 ; AND SYNC BYTE, MACHINE CODE HEADER
 	CALL	0212H
 	CALL	0287H
 	LD	A,55H
 	CALL	WRTBYT
 ; WRITE NAME TO TAPE UNTIL
 ; COMMA DELIMITER IS FOUND
 	LD	B,06
 NAME99	CALL	BYTE
 	CP	2CH
 	JR	Z,NXTB99
 	CALL	WRTBYT
 	DJNZ	NAME99
 	JR	DUMP99
 ; FILL OUT WITH BLANKS IN NAME
 ; LESS THAN 6 CHARACTERS
 NXTB99	LD	A,20H
 	CALL	WRTBYT
 	DJNZ	NXTB99
 ; CHECK FOR COMMA DELIMITER
 DUMP99	CALL	BYTE
 	CP	2CH
 	JR	NZ,SYN2
 ; GET START ADDRESS AND SAVE
 	CALL	XX99
 	PUSH	DE
 ; CHECK FOR NEXT COMMA DELIMITER
 	CALL	BYTE
 	CP	2CH
 	JR	Z,TTTT
 	POP	DE
 	XOR	A
 	JP	24A0H
 ; GET END ADDRESS AND SAVE
 TTTT	CALL	XX99
 	PUSH	DE
 ; EXECUTION ADDRESS AFTER FINAL COMMA
 	CALL	BYTE
 	CP	2CH
 	JR	Z,EXECU
 ; AUTOEXECUTE 06CC IF NOT SPECIFIED
 	LD	HL,06CCH
 	LD	(407EH),HL
 	JR	WRIT99
 ; GET EXECUTION ADDRESS
 EXECU	CALL	XX99
 	LD	(407EH),DE
 ; 16-BIT SUBTRACTION GETS NUMBER OF
 ; BYTES; GET START ADDR. & COMPL'T.
 WRIT99	POP	HL
 	POP	DE
 	PUSH	DE
 	LD	A,D
 	CPL
 	LD	D,A
 	LD	A,E
 	CPL
 	LD	E,A
 ; END ADDRESS + COMPL'T = BYTES
 ; ADD 1 FOR SUB, 1 FOR INCLUSIVE
 	ADD	HL,DE
 	INC	HL
 	INC	HL
 ; TRANSFER BYTES TO WRITE TO DE
 	PUSH	HL
 	POP	DE
 ; RESTORE START ADDRESS TO HL
 	POP	HL
 	LD	B,E
 ; ZERO E REGISTER, INC D, TO GET
 ; TOTAL NUMBER OF PAGES; SAVE IT
 	INC	B
 	INC	D
 LP99	PUSH	DE
 	CALL	OUTSEQ
 ; CHECK IF ALL PAGES WRITTEN
 	POP	DE
 	DEC	D
 	JR	NZ,LP99
 ; WRITE END OF PROGRAM CODE
 	LD	A,78H
 	CALL	WRTBYT
 ; WRITE START ADDRESS; 06CC = DEFAULT
 	LD	A,(407EH)
 	CALL	WRTBYT
 	LD	A,(407FH)
 	CALL	WRTBYT
 ; RETURN TO COMMAND LEVEL
 	JR	PREP2
 ; START SETUP OF STEPPER ROUTINE
 ; FIRST FIND IF ARGUMENT EXISTS
 STPSET	PUSH	AF
 	PUSH	HL
 	CALL	BYTE
 	OR	A
 ; ARGUMENT EXISTS - JUMP TO ROUTINE
 	JR	NZ,IIII
 ; OTHERWISE JUMP PAST SINGLE STEPPER
 	LD	(IY+4),SKPSTP&00FFH
 	LD	(IY+5),SKPSTP&0FF00H<-8
 	POP	HL
 	POP	AF
 	JR	PREP2
 ; GET VALUE FROM A REGISTER INTO D
 IIII	SUB	30H
 	RLA
 	RLA
 	RLA
 	RLA
 	LD	D,A
 ; GET NEXT BUFFER VALUE ELSE SN ERROR
 	CALL	BYTE
 	OR	A
 	JR	NZ,ABCD
 	POP	HL
 	POP	AF
 SYN3	JP	SYNERR
 ; GET NEXT VALUE FROM BUFFER INTO E
 ABCD	SUB	30H
 	ADD	A,D
 	LD	D,A
 ; PATCH STEPPER INTO PLACE
 	LD	(IY+4),JMPPOS&00FFH
 	LD	(IY+5),JMPPOS&0FF00H<-8
 ; GET DELAY VALUE INTO REGISTER
 ; AND GO OUT TO READY PROMPT
 	LD	(IY+6),D
 	POP	HL
 	POP	AF
 PREP2	JP	READY
 ; THIS IS THE STEPPER ROUTINE
 JMPPOS	EQU	$
 STEPPR	PUSH	AF
 	PUSH	BC
 ; WAIT FOR SHIFT TO BE PRESSED
 LUPER	LD	A,(3880H)
 	AND	A
 	JR	Z,LUPER
 ; LOAD DELAY VALUE INTO BC
 	LD	C,A
 	LD	B,(IY+6)
 ; CALL DELAY IN ROM
 	CALL	0060H
 	POP	BC
 	POP	AF
 ; BACK TO REST OF TEST SEQUENCE
 	JP	BEGIN
 ; BEGIN MEMORY RESET SEQUENCE
 ; CHECK FOR QUOTE MARK DELIMITER
 MEMSET	CALL	BYTE
 	CP	22H
 	JR	NZ,SYN3
 ; CONVERT *MEM OPERAND TO HEX
 	CALL	XX99
 ; CHECK FOR >4400H MEMORY ADDRESS
 ; GO TO OM ERROR IF NOT ENOUGH
 	LD	HL,4400H
 	XOR	A
 	SBC	HL,DE
 	JP	NC,197AH
 ; TEST FOR MEMORY RESET <FBBBH
 ; OM ERROR IF TOO MUCH
 	PUSH	DE
 	POP	HL
 	LD	B,7
 	INC	HL
 	DJNZ	$-1
 	LD	A,(HL)
 	LD	B,A
 	CPL
 	LD	(HL),A
 	CP	(HL)
 	JP	NZ,197AH
 	LD	(HL),B
 ; PUT NEW MEMORY SIZE INTO PLACE
 	LD	(40B1H),DE
 ; TRANSFER KEEPIT DATA ROW
 ; AND PUT NEW ADDRESS IN IY
 	PUSH	IY
 	POP	HL
 	INC	DE
 	PUSH	DE
 	POP	IY
 	LD	BC,7
 	LDIR
 	PUSH	IY
 	POP	HL
 ; MAKE FRE(A$) MEM SIZE - 50 DECIMAL
 	LD	B,32H
 STRING	DEC	DE
 	DJNZ	STRING
 ; PUT NEW STRING POINTER IN PLACE
 	LD	(40A0H),DE
 	JP	GRINS
 ; THIS IS LOWER CASE DETERMINATION
 LOWER	PUSH	AF
 	LD	A,(SHIFTR)
 	CP	1
 	JR	Z,LOWER1
 	POP	AF
 	JP	0458H
 LOWER1	POP	AF
 	LD	L,(IX+3)
 	LD	H,(IX+4)
 	JP	C,049AH
 	LD	A,(IX+5)
 	OR	A
 	JR	Z,GETCHR
 	LD	(HL),A
 GETCHR	LD	A,C
 	CP	20H
 	JP	C,0506H
 	CP	80H
 	JP	NC,04A6H
 	JP	047DH
 INTRO1	DEFM	'*FIX = SET DEBOUNCE/BEEP/AUTOREPEAT'
 	DEFB	0AH
 	DEFM	'*KILL = RESET TO NORMAL KEYBOARD'
 	DEFB	0AH
 	DEFM	'*MEM = RESET MEMORY SIZE (NOTE 1)
 	DEFB	0DH
 	DEFB	00H
 INTRO2	DEFM	'*PRINT = LOWERCASE KEYBOARD/DISPLAY ON'
 	DEFB	0AH
 	DEFM	'*OUT = LOWERCASE KEYBOARD/DISPLAY OFF'
 	DEFB	0AH
 	DEFM	'*NEW = RESTORE PROGRAM VICTIM OF NEW'
 	DEFB	0AH
 	DEFM	'*OPEN = HEX/ASCII/GRAPHICS MONITOR (NOTE 1)'
 	DEFB	0DH
 	DEFB	00H
 INTRO3	DEFM	'*SAVE/RUN = SAVE RUNNING PROGRAM (NOTE 2)'
 	DEFB	0AH
 	DEFM	'*SAVE/OPEN = MEMORY BLOCK SAVE (NOTE 3)'
 	DEFB	0AH
 	DEFM	'*STEPXX = SINGLE STEPPER ON, XX = DELAY'
 	DEFB	0AH
 	DEFM	'*STEP = SINGLE STEPPER OFF'
 	DEFB	0DH
 	DEFB	00
 INTRO4	DEFM	'NOTE 1.  REQUIRES 4-CHARACTER HEX VALUE IN QUOTES.'
 	DEFB	0AH
 	DEFM	'NOTE 2.  REQUIRES 6-CHARACTER NAME IN QUOTES.'
 	DEFB	0AH
 	DEFM	'NOTE 3.  SAME AS ABOVE PLUS HEX START, END, OPTIONAL ENTRY'
 	DEFB	0DH
 	DEFB	00H
 	END	START
